//***************************************************************************
//
//  ̧......: RTC.c
//  ......: ATMEL Norway
//  Ώ......: ATmega169
//  ߲....: IAR EWAAVR 2.27b
//  e......: Ԍv(RTC)
//  Ŕԍ....: 1.0
//
//  N   - VER. - 											- 
//  20021015 - 1.0  - 쐬											- LHM
//
//***************************************************************************

#include <inavr.h>
#include "iom169.h"
#include "main.h"
#include "RTC.h"
#include "LCD_functions.h"
#include "BCD.h"

/* ϐ` */

char gSECOND;													// bvl
char gMINUTE;													// vl
char gHOUR;														// vl
char gDAY;														// vl
char gMONTH;													// vl
unsigned int gYEAR;												// Nvl
char gPowerSaveTimer = 0;										// ȓd͓ڍsԌvl
char dateformat = 0;											// N\`ԍ

/* /Ή\ (擪͖) */
char MonthLength[13] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
/* 2412ԕ\Z\ */
char TBL_CLOCK_12[] =
{12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11};
char clockformat = CLOCK_24;									// 12/24ԕ\׸

__flash char EUROPEAN_DATE_TEXT[] = "DDMMYY";					// "N"
__flash char AMERICAN_DATE_TEXT[] = "MMDDYY";					// "N"
__flash char CANADIAN_DATE_TEXT[] = "YYMMDD";					// "N"
/* \\ */
__flash char EUROPEAN_DATE_NR[] = { 4, 5, 2, 3, 0, 1 };			// N
__flash char AMERICAN_DATE_NR[] = { 4, 5, 0, 1, 2, 3 };			// N
__flash char CANADIAN_DATE_NR[] = { 0, 1, 2, 3, 4, 5 };			// N
/* N\`ʒu\ʒu\ */
__flash char __flash *DATEFORMAT_TEXT[] = {EUROPEAN_DATE_TEXT, AMERICAN_DATE_TEXT, CANADIAN_DATE_TEXT};
__flash char __flash *DATE_FORMAT_NR[] = {EUROPEAN_DATE_NR, AMERICAN_DATE_NR, CANADIAN_DATE_NR};

//*****************************************************************************
//*
//*	֐	: RTC_init
//*		: Ȃ
//*	߂l	: Ȃ
//*	ړI	: 32.768kHz񓯊/2n
//*
//*****************************************************************************

void RTC_init(void)
{
	Delay(1000);												// dON̸ؽٔU莞(=1s)ҋ@
	__disable_interrupt();										// S荞݋֎~
	cbi(TIMSK2, TOIE2);											// /2 ް۰荞݋֎~
	ASSR = (1<<AS2);											// /2񓯊ݒ
	TCNT2 = 0;													// /2vl
	TCCR2A |= (1<<CS22) | (1<<CS20);							// 128Ou(32.768kHz/128/256=1s)/2n
	while((ASSR & 0x01) | (ASSR & 0x04));						// /2֌Wڼ޽XV܂őҋ@
	TIFR2 = 0xFF;												// /2S荞ݗv׸މ
	sbi(TIMSK2, TOIE2);											// /2 ް۰荞݋
	__enable_interrupt();										// S荞݋
	gSECOND  = 0;												// bvl
	gMINUTE  = 0;												// vl
	gHOUR    = 12;												// vl
	gDAY     = 1;												// vl
	gMONTH   = 1;												// vl
	gYEAR    = 3;												// Nvl
}

//*****************************************************************************
//*
//*	֐	: ShowClock
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: LCD\
//*
//*****************************************************************************

char ShowClock(char input)
{
	char HH, HL, MH, ML, SH, SL;								// be10/1̌

	if (clockformat == CLOCK_12)								// 12ԕ\`wȂA
		HH = CHAR2BCD2(TBL_CLOCK_12[gHOUR]);					// 12ԕ\lϊA2߯BCDl擾
	else														// 24ԕ\`wȂA
		HH = CHAR2BCD2(gHOUR);									// vl2߯BCDl擾
	HL = (HH & 0x0F) + '0';										// 1̌擾
	HH = (HH >> 4) + '0';										// 10̌擾
	MH = CHAR2BCD2(gMINUTE);									// vl2߯BCDl擾
	ML = (MH & 0x0F) + '0';										// 1̌擾
	MH = (MH >> 4) + '0';										// 10̌擾
	SH = CHAR2BCD2(gSECOND);									// bvl2߯BCDl擾
	SL = (SH & 0x0F) + '0';										// b1̌擾
	SH = (SH >> 4) + '0';										// b10̌擾
	LCD_putc(0, HH);											// LCDޯ̧1Ɏ10̌ݒ
	LCD_putc(1, HL);											// LCDޯ̧2Ɏ1̌ݒ
	LCD_putc(2, MH);											// LCDޯ̧3ɕ10̌ݒ
	LCD_putc(3, ML);											// LCDޯ̧4ɕ1̌ݒ
	LCD_putc(4, SH);											// LCDޯ̧5ɕb10̌ݒ
	LCD_putc(5, SL);											// LCDޯ̧6ɕb1̌ݒ
	LCD_putc(6, '\0');											// LCDޯ̧7ɏIqݒ
	LCD_Colon(1);												// LCD(:)\ON׸ސݒ
	LCD_UpdateRequired(TRUE, 0);								// LCD\XV׸ސݒ
	if (input == KEY_PREV)										// ޮèONȂA
		return ST_TIME_CLOCK;									// ""ƭԔԍƋɕA
	else if (input == KEY_NEXT)									// ޮèONȂA
		return ST_TIME_CLOCK_ADJUST;							// "ԕύX"ƭԔԍƋɕA
	return ST_TIME_CLOCK_FUNC;									// ̑ȂA\ԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: SetClock
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: ύX
//*
//*****************************************************************************

/* ҏWڔԍ萔` */

#define HOUR		0
#define MINUTE		1
#define SECOND		2

char SetClock(char input)
{
	static char enter_function = 1;								// ׸
	static char time[3];										// bҏWl
	static char mode = HOUR;									// ҏWڔԍ
	char HH, HL, MH, ML, SH, SL;								// be10/1̌

	if (enter_function)											/* 񎞏 */
	{
		time[HOUR] = gHOUR;										// vl
		time[MINUTE] = gMINUTE;									// vl
		time[SECOND] = gSECOND;									// bvl
	}
	if (clockformat == CLOCK_12)								// 12ԕ\`wȂA
		HH = CHAR2BCD2(TBL_CLOCK_12[time[HOUR]]);				// 12ԕ\lϊA2߯BCDl擾
	else														// 24ԕ\`wȂA
		HH = CHAR2BCD2(time[HOUR]);								// ҏWl2߯BCDl擾
	HL = (HH & 0x0F) + '0';										// 1̌擾
	HH = (HH >> 4) + '0';										// 10̌擾
	MH = CHAR2BCD2(time[MINUTE]);								// ҏWl2߯BCDl擾
	ML = (MH & 0x0F) + '0';										// 1̌擾
	MH = (MH >> 4) + '0';										// 10̌擾
	SH = CHAR2BCD2(time[SECOND]);								// bҏWl2߯BCDl擾
	SL = (SH & 0x0F) + '0';										// b1̌擾
	SH = (SH >> 4) + '0';										// b10̌擾
	LCD_putc(0, HH | ((mode == HOUR) ? 0x80 : 0x00));			// LCDޯ̧1ɕҏWΉȂ_ŎwŎ10̌ݒ
	LCD_putc(1, HL | ((mode == HOUR) ? 0x80 : 0x00));			// LCDޯ̧2ɕҏWΉȂ_ŎwŎ1̌ݒ
	LCD_putc(2, MH | ((mode == MINUTE) ? 0x80 : 0x00));			// LCDޯ̧3ɕҏWΉȂ_Ŏwŕ10̌ݒ
	LCD_putc(3, ML | ((mode == MINUTE) ? 0x80 : 0x00));			// LCDޯ̧3ɕҏWΉȂ_Ŏwŕ1̌ݒ
	LCD_putc(4, SH | ((mode == SECOND) ? 0x80 : 0x00));			// LCDޯ̧3ɕҏWΉȂ_Ŏwŕb10̌ݒ
	LCD_putc(5, SL | ((mode == SECOND) ? 0x80 : 0x00));			// LCDޯ̧3ɕҏWΉȂ_Ŏwŕb1̌ݒ
	LCD_putc(6, '\0');											// LCDޯ̧7ɏIqݒ
	LCD_Colon(1);												// LCD(:)\ON׸ސݒ
	if (input != KEY_NULL)										// ꂩ̽ONȂALCD_Ŏv
		LCD_FlashReset();
	LCD_UpdateRequired(TRUE, 0);								// LCD\XV׸ސݒ
	enter_function = 1;											// ׸ސݒ
	/* Ή */
	if (input == KEY_PLUS)										/* ޮèON */
		time[mode]++;											// ΉҏW(//b)lis
	else if (input == KEY_MINUS)								/* ޮèON */
		time[mode]--;											// ΉҏW(//b)l
	else if (input == KEY_PREV)									/* ޮèON */
	{
		if (mode == HOUR)										// ݎҏWȂAbҏWڔԍݒ
			mode = SECOND;
		else													// ݎȊOҏWȂAҏWڔԍ
			mode--;
	}
	else if (input == KEY_NEXT)									/* ޮèON */
	{
		if (mode == SECOND)										// ݕbҏWȂAҏWڔԍݒ
			mode = HOUR;
		else													// ݕbȊOҏWȂAҏWڔԍis
			mode++;
	}
	else if (input == KEY_ENTER)								/* ޮèON */
	{
		__disable_interrupt();									// S荞݋֎~
		gHOUR = time[HOUR];										// ҏWlˎvl
		gMINUTE = time[MINUTE];									// ҏWl˕vl
		gSECOND = time[SECOND];									// bҏWl˕bvl
		__enable_interrupt();									// S荞݋
		mode = HOUR;											// ҏWڔԍ(p)
		return ST_TIME_CLOCK_FUNC;								// \ԔԍƋɕA
	}
	/* l͈͋K */
	if (time[HOUR] == 255)										// ҏWľނɂ鉺߂ȂAőlɕύX
		time[HOUR] = 23;
	if (time[HOUR] > 23)										// ҏWl̐isɂ߂ȂAŏlɕύX
		time[HOUR] = 0;

	if (time[MINUTE] == 255)									// ҏWľނɂ鉺߂ȂAőlɕύX
		time[MINUTE] = 59;
	if (time[MINUTE] > 59)										// ҏWl̐isɂ߂ȂAŏlɕύX
		time[MINUTE] = 0;

	if (time[SECOND] == 255)									// bҏWľނɂ鉺߂ȂAőlɕύX
		time[SECOND] = 59;
	if (time[SECOND] > 59)										// bҏWl̐isɂ߂ȂAŏlɕύX
		time[SECOND] = 0;
	enter_function = 0;											// ׸މ
	return ST_TIME_CLOCK_ADJUST_FUNC;							// ύXԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: SetClockFormat
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: \`ύX
//*
//*****************************************************************************

char SetClockFormat(char input)
{
	static char enter = 1;										// ׸

	if(enter)													/* 񎞏 */
	{
		enter = 0;												// ׸މ
		if(clockformat == CLOCK_24)								// ݂24ԕ\`ȂA
			LCD_puts("24H", 1);									// LCDޯ̧"24H"ݒ
		else													// ݂12ԕ\`ȂA
			LCD_puts("12H", 1);									// LCDޯ̧"12H"ݒ
	}
	if (input == KEY_PLUS)										/* ޮèON */
	{
		if(clockformat == CLOCK_24)								// ݂24ԕ\`ȂA
		{
			clockformat = CLOCK_12;								// \`12ԕ\`ɐݒ
			LCD_puts("12H", 1);									// LCDޯ̧"12H"ݒ
		}
		else													// ݂12ԕ\`ȂA
		{
			clockformat = CLOCK_24;								// \`24ԕ\`ɐݒ
			LCD_puts("24H", 1);									// LCDޯ̧"24H"ݒ
		}
	}
	else if (input == KEY_MINUS)								/* ޮèON */
	{
		if(clockformat == CLOCK_12)								// ݂12ԕ\`ȂA
		{
			clockformat = CLOCK_24;								// \`24ԕ\`ɐݒ
			LCD_puts("24H", 1);									// LCDޯ̧"24H"ݒ
		}
		else													// ݂24ԕ\`ȂA
		{
			clockformat = CLOCK_12;								// \`12ԕ\`ɐݒ
			LCD_puts("12H", 1);									// LCDޯ̧"12H"ݒ
		}
	}
	else if (input == KEY_ENTER)								/* ޮèON */
	{
		enter = 1;												// ׸ސݒ
		return ST_TIME_CLOCK_FUNC;								// \ԔԍƋɕA
	}
	return ST_TIME_CLOCKFORMAT_ADJUST_FUNC;						// \`ύXԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: ShowDate
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: LCDɔN\
//*
//*****************************************************************************

char ShowDate(char input)
{
	char YH, YL, MH, ML, DH, DL;								// Ne10/1̌

	YH = CHAR2BCD2(gYEAR);										// N()vl2߯BCDl擾
	YL = (YH & 0x0F) + '0';										// N1̌擾
	YH = (YH >> 4) + '0';										// N10̌擾
	MH = CHAR2BCD2(gMONTH);										// vl2߯BCDl擾
	ML = (MH & 0x0F) + '0';										// 1̌擾
	MH = (MH >> 4) + '0';										// 10̌擾
	DH = CHAR2BCD2(gDAY);										// vl2߯BCDl擾
	DL = (DH & 0x0F) + '0';										// 1̌擾
	DH = (DH >> 4) + '0';										// 10̌擾
	LCD_putc( *(DATE_FORMAT_NR[dateformat] + 0), YH);			// LCDޯ̧1ɔN10̌ݒ
	LCD_putc( *(DATE_FORMAT_NR[dateformat] + 1), YL);			// LCDޯ̧2ɔN1̌ݒ
	LCD_putc( *(DATE_FORMAT_NR[dateformat] + 2), MH);			// LCDޯ̧3Ɍ10̌ݒ
	LCD_putc( *(DATE_FORMAT_NR[dateformat] + 3), ML);			// LCDޯ̧4Ɍ1̌ݒ
	LCD_putc( *(DATE_FORMAT_NR[dateformat] + 4), DH);			// LCDޯ̧5ɓ10̌ݒ
	LCD_putc( *(DATE_FORMAT_NR[dateformat] + 5), DL);			// LCDޯ̧6ɓ1̌ݒ
	LCD_putc(6, '\0');											// LCDޯ̧7ɏIqݒ
	LCD_Colon(1);												// LCD(:)\ON׸ސݒ
	LCD_UpdateRequired(TRUE, 0);								// LCD\XV׸ސݒ
	if (input == KEY_PREV)										// ޮèONȂA
		return ST_TIME_DATE;									// "t"ƭԔԍƋɕA
	else if (input == KEY_NEXT)									// ޮèONȂA
		return ST_TIME_DATE_ADJUST;								// "tύX"ƭԔԍƋɕA
	else														// ̼̑ޮèԂȂA
		return ST_TIME_DATE_FUNC;								// t\ԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: SetDate
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: NύX
//*
//*****************************************************************************

/* ҏWڔԍ萔` */

#define YEAR		0
#define MONTH		1
#define DAY			2

char SetDate(char input)
{
	static char enter_function = 1;								// ׸
	static char date[3];										// NҏWl
	static char mode = DAY;										// ҏWڔԍ
	char YH, YL, MH, ML, DH, DL;								// Ne10/1̌
	char MonthLength_temp;										// /Ή
	char LeapMonth;												// [N׸

	if (enter_function)											/* 񎞏 */
	{
		date[YEAR] = gYEAR;										// Nvlʕ
		date[MONTH] = gMONTH;									// vlʕ
		date[DAY] = gDAY;										// vlʕ
	}
	if (mode == YEAR)											/* NҏW */
	{
		YH = CHAR2BCD2(date[YEAR]);								// NʕҏWl2߯BCDl擾
		YL = (YH & 0x0F) + '0';									// N1̌擾
		YH = (YH >> 4) + '0';									// N10̌擾
		LCD_putc( 0, ' ');										// LCDޯ̧1ɋ󔒕ݒ
		LCD_putc( 1, ' ');										// LCDޯ̧2ɋ󔒕ݒ
		LCD_putc( 2, 'Y');										// LCDޯ̧3'Y'ݒ
		LCD_putc( 3, 'Y');										// LCDޯ̧4'Y'ݒ
		LCD_putc( 4, YH);										// LCDޯ̧5ɔN10̌ݒ
		LCD_putc( 5, YL);										// LCDޯ̧6ɔN1̌ݒ
	}
	else if (mode == MONTH)										/* ҏW */
	{
		MH = CHAR2BCD2(date[MONTH]);							// ҏWl2߯BCDl擾
		ML = (MH & 0x0F) + '0';									// 1̌擾
		MH = (MH >> 4) + '0';									// 10̌擾
		LCD_putc( 0, ' ');										// LCDޯ̧1ɋ󔒕ݒ
		LCD_putc( 1, ' ');										// LCDޯ̧2ɋ󔒕ݒ
		LCD_putc( 2, 'M');										// LCDޯ̧3'M'ݒ
		LCD_putc( 3, 'M');										// LCDޯ̧4'M'ݒ
		LCD_putc( 4, MH);										// LCDޯ̧5Ɍ10̌ݒ
		LCD_putc( 5, ML);										// LCDޯ̧6Ɍ1̌ݒ
	}
	else if (mode == DAY)										/* ҏW */
	{
		DH = CHAR2BCD2(date[DAY]);								// ҏWl2߯BCDl擾
		DL = (DH & 0x0F) + '0';									// 1̌擾
		DH = (DH >> 4) + '0';									// 10̌擾
		LCD_putc( 0, ' ');										// LCDޯ̧1ɋ󔒕ݒ
		LCD_putc( 1, ' ');										// LCDޯ̧2ɋ󔒕ݒ
		LCD_putc( 2, 'D');										// LCDޯ̧3'D'ݒ
		LCD_putc( 3, 'D');										// LCDޯ̧4'D'ݒ
		LCD_putc( 4, DH);										// LCDޯ̧5ɓ10̌ݒ
		LCD_putc( 5, DL);										// LCDޯ̧6ɓ1̌ݒ
	}
	LCD_putc(6, '\0');											// LCDޯ̧7ɏIqݒ
	LCD_Colon(0);												// LCD(:)\ON׸މ
	if (input != KEY_NULL)										// ꂩ̽ONȂALCD_Ŏv
		LCD_FlashReset();
	LCD_UpdateRequired(TRUE, 0);								// LCD\XV׸ސݒ
	enter_function = 1;											// ׸ސݒ
    /* Ή */
	if (input == KEY_PLUS)										/* ޮèON */
		date[mode]++;											// ΉҏW(N//)lis
	else if (input == KEY_MINUS)								/* ޮèON */
		date[mode]--;											// ΉҏW(N//)l
	else if (input == KEY_PREV)									/* ޮèON */
	{
		if (mode == YEAR)										// ݔNҏWȂAҏWڔԍݒ
			mode = DAY;
		else													// ݔNȊOҏWȂAҏWڔԍ
			mode--;
	}
	else if (input == KEY_NEXT)									/* ޮèON */
	{
		if (mode == DAY)										// ݓҏWȂANҏWڔԍݒ
			mode = YEAR;
		else													// ݓȊOҏWȂAҏWڔԍis
			mode++;
	}
	else if (input == KEY_ENTER)								/* ޮèON */
	{
		__disable_interrupt();									// S荞݋֎~
		gYEAR = date[YEAR];										// NʎҏWl˔Nvl
		gMONTH = date[MONTH];									// ҏWlˌvl
		gDAY = date[DAY];										// ҏWl˓vl
		__enable_interrupt();									// S荞݋
		mode = YEAR;											// ҏWڔԍ(p)
		return ST_TIME_DATE_FUNC;								// t\ԔԍƋɕA
	}
	/* l͈͋K */
	if (date[YEAR] == 255)										// NҏWľނɂ鉺߂ȂAőlɕύX
		date[YEAR] = 99;
	if (date[YEAR] > 99)										// NҏWl̐isɂ߂ȂAŏlɕύX
		date[YEAR] = 0;
	if (date[MONTH] == 0)										// ҏWľނɂ鉺߂ȂAőlɕύX
		date[MONTH] = 12;
	if (date[MONTH] > 12)										// ҏWl̐isɂ߂ȂAŏlɕύX
		date[MONTH] = 1;
	/* 2̏ꍇɉ[Nœ␳ */
	if (gMONTH == 2)											/* 2 */
		if (!(gYEAR & 0x0003))									/* (4̔{N) */
			if (gYEAR%100 == 0)									/* ((100̔{N)) */
				if (gYEAR%400 == 0)								// 4,100,400̔{Nŉ[N׸ސݒ
					LeapMonth = 1;
				else											// 4,100̔{N400̔{NȊOŉ[N׸މ
					LeapMonth = 0;
			else												// 4̔{N100̔{NȊOŉ[N׸ސݒ
				LeapMonth = 1;
		else													// 4,100̔{NȊOŉ[N׸މ
			LeapMonth = 0;
	else														// 2ȊOŉ[N׸މ
		LeapMonth = 0;
	if (LeapMonth)												// [N2ȂA29ɐݒ
		MonthLength_temp = 29;
	else														// [NȊO܂2ȊOȂAΉ̓擾
		MonthLength_temp = MonthLength[date[MONTH]];
	if (date[DAY] == 0)											// ҏWľނɂ鉺߂ȂAőlɕύX
		date[DAY] = MonthLength_temp;
	if (date[DAY] > MonthLength_temp)							// ҏWl̐isɂ߂ȂAŏlɕύX
		date[DAY] = 1;
	enter_function = 0;											// ׸މ
	return ST_TIME_DATE_ADJUST_FUNC;							// tύXԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: SetDateFormat
//*		: char input (ޮèԔԍ)
//*	߂l	: char ST_state (S̏Ԕԍ)
//*	ړI	: N\`ύX
//*
//*****************************************************************************

char SetDateFormat(char input)
{
	static char enter = 1;										// ׸
    
	if(enter)													/* 񎞏 */
	{
		enter = 0;												// ׸މ
		LCD_puts_f(DATEFORMAT_TEXT[dateformat], 1);				// Ή\`LCDޯ̧ɐݒ
	}
	if (input == KEY_PLUS)										/* ޮèON */
	{
		if(dateformat >= 2)										// "N"`wȂA"N"`ԍɕύX
			dateformat = 0;
		else													// "N"`wȂA`ԍis
			dateformat++;
		LCD_puts_f(DATEFORMAT_TEXT[dateformat], 1);				// Ή\`LCDޯ̧ɐݒ
	}
	else if (input == KEY_MINUS)								/* ޮèON */
	{
		if(dateformat == 0)										// "N"`wȂA"N"`ԍɕύX
			dateformat = 2;
		else													// "N"`wȂA`ԍ
			dateformat--;
		LCD_puts_f(DATEFORMAT_TEXT[dateformat], 1);				// Ή\`LCDޯ̧ɐݒ
	}
	else if (input == KEY_ENTER)								/* ޮèON */
	{
		enter = 1;												// ׸ސݒ
		return ST_TIME_DATE_FUNC;								// t\ԔԍƋɕA
	}
	return ST_TIME_DATEFORMAT_ADJUST_FUNC;						// t\`ύXԔԍƋɕA
}

//*****************************************************************************
//*
//*	֐	: TIMER2_OVF_interrupt (/2 ް۰荞ݏٰ)
//*	ړI	: Ԍv(32.768kHzؽقɂ1sɔ)
//*
//*****************************************************************************

#pragma vector = TIMER2_OVF_vect
__interrupt void TIMER2_OVF_interrupt(void)
{
	static char LeapMonth;										// [N׸

	gSECOND++;													// bvlis
	if (gSECOND == 60)											/* bvlߎ */
	{
		gSECOND = 0;											// bvl
		gMINUTE++;												// vlis
		gPowerSaveTimer++;										// ȓd͓ڍsԌvlis
		if (gMINUTE > 59)										/* (vlߎ) */
		{
			gMINUTE = 0;										// vl
			gHOUR++;											// vlis
			if (gHOUR > 23)										/* ((vlߎ)) */
			{
				gHOUR = 0;										// vl
				gDAY++;											// vlis
				/* 2̏ꍇɉ[Nœ␳ */
				if (gMONTH == 2)								/* (((2))) */
					if (!(gYEAR & 0x0003))						/* ((((4̔{N)))) */
						if (gYEAR%100 == 0)						/* (((((100̔{N))))) */
							if (gYEAR%400 == 0)					// 4,100,400̔{Nŉ[N׸ސݒ
								LeapMonth = 1;
							else								// 4,100̔{N400̔{NȊOŉ[N׸މ
								LeapMonth = 0;
						else									// 4̔{N100̔{NȊOŉ[N׸ސݒ
							LeapMonth = 1;
					else										// 4,100̔{NȊOŉ[N׸މ
						LeapMonth = 0;
				else											// 2ȊOŉ[N׸މ
					LeapMonth = 0;
				if (gDAY > (MonthLength[gMONTH] + LeapMonth))	/* (((vlߎ))) */
				{
					gDAY = 1;									// vl
					gMONTH++;									// vlis
					if (gMONTH > 12)							/* ((((vlߎ)))) */
					{
						gMONTH = 1;								// vl
						gYEAR++;								// Nvlis
					}
				}
			}
		}
	}
}
